turf/Enter(A)	//Enter is no longer used to handle collisions. Instead:
//only for specific allow/deny instances (see below), SO:
	return call(/atom/Enter)(A,src)	//go to atom/Enter() instead
//I can't use ..() here or that will call the built in variant instead of the parent

/*
Odd Update... A runtime error appeared here that I never noticed before, so I figured I would fix it.
Not sure why but it is no longer passing the src to the call()'d proc
*/



/*
The above line has to be here because I use Enter() differently than
the hard coded variant.

Typicallly, BYOND's turf/Enter() will do a collision check for all dense objects
in the turf's contents. We don't want this, because we have many Z ranges and
far more dynamic collisions and landings and all that.

The use of Enter() here is to allow control over when someone is allowed to use
a specific location as a floor or not. This applies to everything.


*/
















/*
Northeast requires north & east, but also enables north or east entry
No way to allow entry ONLY from a diagonal and not its corresponding sides
*/


atom/Enter(atom/movable/A,FailSafe)
	if(!src) src=FailSafe	//Workaround because of a glitch that arose with call()
	if(EnterBit)
		var/Dir=turn(A.dir,180) //This is because if you want to enter from the NORTH your
		//dir needs to be SOUTH
		if(EnterBit&NORTH	&&	Dir==NORTH	) return 1
		if(EnterBit&EAST	&&	Dir==EAST		) return 1
		if(EnterBit&WEST	&&	Dir==WEST			) return 1
		if(EnterBit&SOUTH	&&	Dir==SOUTH	) return 1
		if(EnterBit&NORTHEAST	&&	Dir==NORTHEAST) return 1
		if(EnterBit&SOUTHEAST	&&	Dir==SOUTHEAST) return 1
		if(EnterBit&NORTHWEST	&&	Dir==NORTHWEST) return 1
		if(EnterBit&SOUTHWEST	&&	Dir==SOUTHWEST) return 1
		return 0
	return 1

atom/Exit(atom/movable/A)
	if(ExitBit)
		if(EnterBit&NORTH	&&	A.dir==NORTH	) return 1
		if(EnterBit&EAST	&&	A.dir==EAST		) return 1
		if(EnterBit&WEST	&&	A.dir==WEST		) return 1
		if(EnterBit&SOUTH	&&	A.dir==SOUTH	) return 1
		if(EnterBit&NORTHEAST	&&	A.dir==NORTHEAST) return 1
		if(EnterBit&SOUTHEAST	&&	A.dir==SOUTHEAST) return 1
		if(EnterBit&NORTHWEST	&&	A.dir==NORTHWEST) return 1
		if(EnterBit&SOUTHWEST	&&	A.dir==SOUTHWEST) return 1
		return 0
	return 1


