proc/GetStepD(atom/M,NewLoc)
	var/Option=0
	var/atom/Landing
	var/Bumped[]
	var/list/L[0]
	for(var/atom/A in NewLoc)
		if(A==M) continue
		if(!A.density) continue
		L+=A

	L+=NewLoc
	PixZSort(L) //QuickSort L
	for(var/atom/A in L)
		if(A.pixel_z > M.pixel_z+M.Height)
			//High enough to go under
			if(isturf(A)) continue //can't go under this
			if(Option==1) //If you're stepping up
				if(A.pixel_z<M.Height+Landing.pixel_z)//you need to make sure
				//you're not going to hit your head on the roof
					Option=2
					break
			continue

		if(A.pixel_z+A.Height>M.pixel_z && A.pixel_z+A.Height<=M.pixel_z+M.StepHeight)
			if( M.Falling ) //Can't step up if you're falling
				Option=3	//So you bump it and that is that
				if(!Bumped) Bumped=new /list
				Bumped+=A
				continue

			if(!Landing)
				Landing=A
				if(Option<1) Option=1
				continue
			if(Landing.pixel_z+Landing.Height<A.pixel_z+A.Height)
				Landing=A

		else if(A.pixel_z + A.Height > M.pixel_z && M.pixel_z + M.Height > A.pixel_z)
			//Bump check may need to be moved to somewhere else...
			Option=3
			if(!Bumped) Bumped=new /list
			Bumped+=A
			continue

		if(A.pixel_z+A.Height<=M.pixel_z)
			//Falling
			if(Option) continue
			if(!Landing)
				Landing=A
				continue

			if(A.pixel_z+A.Height>Landing.pixel_z+Landing.Height)
				Landing=A




	if(Option==3)
		return Bumped

	if(Option==2)
		return 0

	if(!Landing)
		return 0


	return Landing

proc/GetStep(atom/M,Dir)
	//this merely grabs a dir and then throws direct into it
	var/NewLoc=get_step(M,Dir)
	.=GetStepD(M,NewLoc)









/*
New Loc = get_step(src,dir)
var/Option=0
var/atom/Landing
for(var/atom/A in New Loc)
	if(!A.density) continue
	if(A.pixel_z>M.pixel_z+M.height)
		//High enough to Go under
		if(isturf(A)) continue //cant go under turfs!
		if(Option==1)
			//If we are stepping up we need to make sure there is no low roof
			if(A.pixel_z<M.height+Landing.pixel_z)
				//if the roof is too low for the mover to stand
				Option=2 //on the landing then option==2, fail get_step
				break	//No reason to bother checking anything else
				//because we know that you cant go down (due to the step up)
				//and we cant step up due to the low roof.

		continue

	if(A.pixel_z+A.height<M.pixel_z+step height)
		//can step up to it. this probably should only be 2 pixels up or so
		Option=1 	//Stepping up
		Landing=A
		continue

	if(A.pixel_z+A.height<M.pixel_z)
		//target is lower than starting point,
		//will fall to it if it is the highest option
		if(Option) continue	//Stepping up or low roof, either way cant be going down
		if(!Landing)
			//No need to compare anything
			Landing=A
			continue
		if(A.pixel_z+A.height>Landing.pixel_z+Landing.height)
			//You want to land on the highest possible option
			Landing=A
*/
