
obj/MovingFloor
	icon='Icon.dmi'
	icon_state="Moving Floor"

	name="Moving Floor"
	N/dir=NORTH
	E/dir=EAST
	S/dir=SOUTH
	W/dir=WEST

	Special


		UnderBump
			icon_state="Moving Floor"
			pixel_z=64
			dir=WEST

		Heights
			dir=WEST
			Z4/pixel_z=4
			Z8/pixel_z=8
			Z12/pixel_z=12
			Z16/pixel_z=16
			Z20/pixel_z=20

		ZAdjuster
			//auto sets pixel Z
			dir=EAST
			Delay=1
			New()
				..()
				PixZ(loc.pixel_z)
			West
				dir=WEST

	var/Delay=3 //tenths of a second

	Move(Loc,Dir)
		..(Loc,dir) //lowercase dir to keep current direction

	LandedOn(atom/movable/A)
		while(A.Floor==src)
			.=0
			while(.<Delay&&A.Floor==src)
				.++
				sleep(1)
			if(.==Delay)
				step(A,dir)

	UnderBumped(atom/movable/A)
		step(A,turn(dir,180))