



atom/movable/Move(Loc,Dir)
	//GetStep(atom/M,Dir)

	dir=Dir		//Update your dir!
	if(!Loc)		// if you tried stepping into oblivion
		return 0	// stop here


/*	***** For non validated movements you'll have to set loc/pixel_z manually then move(loc) to make it fall.
	if(get_dist(src,Loc)>1)
		//Need to do something different
		//for longer than 1 step
		//for now it just forces entry
		loc=Loc
		return 1*/

	var/atom/Destination=GetStepD(src,Loc)
	if(!Destination)
		return 0 //if there is no valid destination then this fails

	var/list/L //defining here for later uses

	if(istype(Destination,/list)) 	//if it returned a list that means
		L=Destination		//that you bumped something
		var/atom/A					//or more than one something
		for(var/i=1,i<=L.len,i++)	//so bump() them
			A=L[i]
			Bump(A)
			A.Bumped(src)
			continue
		return 0					//and then fail

	if(!Floor)						//if you dont currently have a floor
		Floor=loc					//Default to the turf you're on

	if(Floor&&Floor.Exit(src,Destination)==0)
	//we call Exit() for the place you're standing on instead of the turf
	//because you're not always standing on the turf itself
		return 0
	if(Destination.Enter(src,Destination)==0)
	//again, enter() is called for the percieved landing zone not
	//the target turf
		return 0
	if(Floor)
		spawn() Floor.Exited(src)	//etc. spawned() because it would lock up this proc otherwise

		if(!isturf(Floor))	//Contents is used for storing people standing on stuff
			Floor.Contents-=src	//that isnt a turf. contents is used for turfs
			if(!Floor.Contents.len) del Floor.Contents	//unload empty lists to avoid clutter
	//the above line used to be Floor.Contents=0, changed it in case of silly programmers
	//leaving around references

	var/OldLoc=Floor
	Floor=Destination //go ahead and move on in

	if(isturf(Destination))
		loc=Destination
		L=Destination.contents //used for the later falling stuff
	else
		loc=Destination.loc
		if(!Floor.Contents) Floor.Contents=new
		Floor.Contents+=src
		L=Destination.Contents	//same as above
	spawn() Destination.Entered(src,OldLoc)

	//Everything standing on the mover needs to fall
	for(var/atom/movable/A in Contents)
		spawn() A.Move(A.loc,A.dir)

	//And everyone above the destination needs to change their floor, probably to the mover

	for(var/atom/movable/A in L)
		if(A.pixel_z>pixel_z) A.Move(A.loc,A.dir)

	spawn() Fall()
	spawn() ShadowUpdate()

/*
1: Move(dir)
2: GetStep(src,dir)
3: Exit()
4: Enter()
5: Exited()
6: Entered()
7: Fall()
8: LandedOn()
9: ILanded()?*/